searchNodes=[{"doc":"","ref":"ChannelHandler.html","title":"ChannelHandler","type":"module"},{"doc":"Lists all functions allowed in the ChannelHandler API. Note the functions in this module exist for documentation purposes and one should never need to invoke them directly.","ref":"ChannelHandler.API.html","title":"ChannelHandler.API","type":"module"},{"doc":"Defines an event handler function for the given event name. If the module defining this is called by another event handler via match , the prefixes of previous handlers won't be included in the event name. For example, if module A defines event &quot;foo&quot; do , and module B matches &quot;app:&quot; , then the event &quot;app:foo&quot; will be matched by B and the handler for &quot;foo&quot; in A will be invoked. plug/1 can be called inside event/2","ref":"ChannelHandler.API.html#event/2","title":"ChannelHandler.API.event/2","type":"function"},{"doc":"When used in join , this is the function to run in the channel's join callback.","ref":"ChannelHandler.API.html#handler/0","title":"ChannelHandler.API.handler/0","type":"function"},{"doc":"When used in event or match , this is the function that will be called to process the event. It's mostly equivalent to a c:Phoehix.Channel.handle_in/3 with the following differences: It takes an additional bindings argument, containing the values stored by previous plugs, for the current event. These are cleared after every event. When used in event , the event argument is omitted as it is redundant. The handler function must return a reply/noreply tuple, just like a regular phoenix event handler. If a module or mfa tuple is provided, the corresponding handle_in function in that module will be called. Modules that use ChannelHandler can be used as well, as they define handle_in functions as well.","ref":"ChannelHandler.API.html#handler/1","title":"ChannelHandler.API.handler/1","type":"function"},{"doc":"Defines the handle_in/3 functions for a Phoenix channel by matching on exact event names, or prefixes.","ref":"ChannelHandler.API.html#handlers/0","title":"ChannelHandler.API.handlers/0","type":"function"},{"doc":"The channel path for this handler. By default this has no runtime effect, but can be used by plugs and handlers if necessary. The channel value is stored in the socket's :__channel__ assign.","ref":"ChannelHandler.API.html#join/0","title":"ChannelHandler.API.join/0","type":"function"},{"doc":"Defines a matcher function for the given event prefix. The prefix is a string literal that will be used to match the start of the event string. The event name without the prefix will be used when delegating to another handler module with handler/1 . plug/1 can be called inside match/2 .","ref":"ChannelHandler.API.html#match/2","title":"ChannelHandler.API.match/2","type":"function"},{"doc":"Registers a plug for the current match or event . Plugs are run in the order they are defined before the event handler.","ref":"ChannelHandler.API.html#plug/1","title":"ChannelHandler.API.plug/1","type":"function"},{"doc":"","ref":"ChannelHandler.Extension.html","title":"ChannelHandler.Extension","type":"module"},{"doc":"","ref":"ChannelHandler.Extension.html#default_extensions/0","title":"ChannelHandler.Extension.default_extensions/0","type":"function"},{"doc":"Callback implementation for Spark.Dsl.explain/2 .","ref":"ChannelHandler.Extension.html#explain/2","title":"ChannelHandler.Extension.explain/2","type":"function"},{"doc":"Callback implementation for Spark.Dsl.handle_opts/1 .","ref":"ChannelHandler.Extension.html#handle_opts/1","title":"ChannelHandler.Extension.handle_opts/1","type":"function"},{"doc":"Callback implementation for Spark.Dsl.init/1 .","ref":"ChannelHandler.Extension.html#init/1","title":"ChannelHandler.Extension.init/1","type":"function"},{"doc":"A module implementing an event handler. Modules that use ChannelHandler already comply with this behaviour, so you should prefer that instead.","ref":"ChannelsHandler.Handler.html","title":"ChannelsHandler.Handler","type":"behaviour"},{"doc":"","ref":"ChannelsHandler.Handler.html#c:handle_in/2","title":"ChannelsHandler.Handler.handle_in/2","type":"callback"},{"doc":"","ref":"ChannelsHandler.Handler.html#c:handle_in/3","title":"ChannelsHandler.Handler.handle_in/3","type":"callback"},{"doc":"A ChannelHandler.Plug , is a function or module that takes the connection socket, the payload and the current handler bindings, and either returns a modified version of each, or directly replies to the client, halting further processing. The plug can either be a module implementing the ChannelHandler.Plug behaviour, or an function of arity 4 Examples def call ( socket , _payload , _bindings , _opts ) do case authenticated? ( socket ) do { :cont , socket , payload , bindings } else { :reply , { :error , &quot;Not authenticated&quot; } , socket } end end","ref":"ChannelsHandler.Plug.html","title":"ChannelsHandler.Plug","type":"behaviour"},{"doc":"","ref":"ChannelsHandler.Plug.html#c:call/4","title":"ChannelsHandler.Plug.call/4","type":"callback"},{"doc":"Apache License Version 2.0, January 2004 http://www.apache.org/licenses/ TERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION 1. Definitions. &quot;License&quot; shall mean the terms and conditions for use, reproduction, and distribution as defined by Sections 1 through 9 of this document. &quot;Licensor&quot; shall mean the copyright owner or entity authorized by the copyright owner that is granting the License. &quot;Legal Entity&quot; shall mean the union of the acting entity and all other entities that control, are controlled by, or are under common control with that entity. For the purposes of this definition, &quot;control&quot; means (i) the power, direct or indirect, to cause the direction or management of such entity, whether by contract or otherwise, or (ii) ownership of fifty percent (50%) or more of the outstanding shares, or (iii) beneficial ownership of such entity. &quot;You&quot; (or &quot;Your&quot;) shall mean an individual or Legal Entity exercising permissions granted by this License. &quot;Source&quot; form shall mean the preferred form for making modifications, including but not limited to software source code, documentation source, and configuration files. &quot;Object&quot; form shall mean any form resulting from mechanical transformation or translation of a Source form, including but not limited to compiled object code, generated documentation, and conversions to other media types. &quot;Work&quot; shall mean the work of authorship, whether in Source or Object form, made available under the License, as indicated by a copyright notice that is included in or attached to the work (an example is provided in the Appendix below). &quot;Derivative Works&quot; shall mean any work, whether in Source or Object form, that is based on (or derived from) the Work and for which the editorial revisions, annotations, elaborations, or other modifications represent, as a whole, an original work of authorship. For the purposes of this License, Derivative Works shall not include works that remain separable from, or merely link (or bind by name) to the interfaces of, the Work and Derivative Works thereof. &quot;Contribution&quot; shall mean any work of authorship, including the original version of the Work and any modifications or additions to that Work or Derivative Works thereof, that is intentionally submitted to Licensor for inclusion in the Work by the copyright owner or by an individual or Legal Entity authorized to submit on behalf of the copyright owner. For the purposes of this definition, &quot;submitted&quot; means any form of electronic, verbal, or written communication sent to the Licensor or its representatives, including but not limited to communication on electronic mailing lists, source code control systems, and issue tracking systems that are managed by, or on behalf of, the Licensor for the purpose of discussing and improving the Work, but excluding communication that is conspicuously marked or otherwise designated in writing by the copyright owner as &quot;Not a Contribution.&quot; &quot;Contributor&quot; shall mean Licensor and any individual or Legal Entity on behalf of whom a Contribution has been received by Licensor and subsequently incorporated within the Work. 2. Grant of Copyright License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable copyright license to reproduce, prepare Derivative Works of, publicly display, publicly perform, sublicense, and distribute the Work and such Derivative Works in Source or Object form. 3. Grant of Patent License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable (except as stated in this section) patent license to make, have made, use, offer to sell, sell, import, and otherwise transfer the Work, where such license applies only to those patent claims licensable by such Contributor that are necessarily infringed by their Contribution(s) alone or by combination of their Contribution(s) with the Work to which such Contribution(s) was submitted. If You institute patent litigation against any entity (including a cross-claim or counterclaim in a lawsuit) alleging that the Work or a Contribution incorporated within the Work constitutes direct or contributory patent infringement, then any patent licenses granted to You under this License for that Work shall terminate as of the date such litigation is filed. 4. Redistribution. You may reproduce and distribute copies of the Work or Derivative Works thereof in any medium, with or without modifications, and in Source or Object form, provided that You meet the following conditions: (a) You must give any other recipients of the Work or Derivative Works a copy of this License; and (b) You must cause any modified files to carry prominent notices stating that You changed the files; and (c) You must retain, in the Source form of any Derivative Works that You distribute, all copyright, patent, trademark, and attribution notices from the Source form of the Work, excluding those notices that do not pertain to any part of the Derivative Works; and (d) If the Work includes a &quot;NOTICE&quot; text file as part of its distribution, then any Derivative Works that You distribute must include a readable copy of the attribution notices contained within such NOTICE file, excluding those notices that do not pertain to any part of the Derivative Works, in at least one of the following places: within a NOTICE text file distributed as part of the Derivative Works; within the Source form or documentation, if provided along with the Derivative Works; or, within a display generated by the Derivative Works, if and wherever such third-party notices normally appear. The contents of the NOTICE file are for informational purposes only and do not modify the License. You may add Your own attribution notices within Derivative Works that You distribute, alongside or as an addendum to the NOTICE text from the Work, provided that such additional attribution notices cannot be construed as modifying the License. You may add Your own copyright statement to Your modifications and may provide additional or different license terms and conditions for use, reproduction, or distribution of Your modifications, or for any such Derivative Works as a whole, provided Your use, reproduction, and distribution of the Work otherwise complies with the conditions stated in this License. 5. Submission of Contributions. Unless You explicitly state otherwise, any Contribution intentionally submitted for inclusion in the Work by You to the Licensor shall be under the terms and conditions of this License, without any additional terms or conditions. Notwithstanding the above, nothing herein shall supersede or modify the terms of any separate license agreement you may have executed with Licensor regarding such Contributions. 6. Trademarks. This License does not grant permission to use the trade names, trademarks, service marks, or product names of the Licensor, except as required for reasonable and customary use in describing the origin of the Work and reproducing the content of the NOTICE file. 7. Disclaimer of Warranty. Unless required by applicable law or agreed to in writing, Licensor provides the Work (and each Contributor provides its Contributions) on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied, including, without limitation, any warranties or conditions of TITLE, NON-INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A PARTICULAR PURPOSE. You are solely responsible for determining the appropriateness of using or redistributing the Work and assume any risks associated with Your exercise of permissions under this License. 8. Limitation of Liability. In no event and under no legal theory, whether in tort (including negligence), contract, or otherwise, unless required by applicable law (such as deliberate and grossly negligent acts) or agreed to in writing, shall any Contributor be liable to You for damages, including any direct, indirect, special, incidental, or consequential damages of any character arising as a result of this License or out of the use or inability to use the Work (including but not limited to damages for loss of goodwill, work stoppage, computer failure or malfunction, or any and all other commercial damages or losses), even if such Contributor has been advised of the possibility of such damages. 9. Accepting Warranty or Additional Liability. While redistributing the Work or Derivative Works thereof, You may choose to offer, and charge a fee for, acceptance of support, warranty, indemnity, or other liability obligations and/or rights consistent with this License. However, in accepting such obligations, You may act only on Your own behalf and on Your sole responsibility, not on behalf of any other Contributor, and only if You agree to indemnify, defend, and hold each Contributor harmless for any liability incurred by, or claims asserted against, such Contributor by reason of your accepting any such warranty or additional liability. END OF TERMS AND CONDITIONS","ref":"license.html","title":"License","type":"extras"},{"doc":"Helpers to organize and route messages in complex Phoenix channels.","ref":"readme.html","title":"Overview","type":"extras"},{"doc":"Add the following to your mix.exs dependencies: { :channel_handler , &quot;~&gt; 0.1.0&quot; }","ref":"readme.html#installation","title":"Overview - Installation","type":"extras"},{"doc":"After defining a channel with vanilla Phoenix's channel : channel &quot;post:*&quot; , MyAppWeb.PostChannel Define your channel handler, and add use ChannelHandler in addition to the use MyAppWeb, :channel : defmodule MyAppWeb.PostChannel do use MyAppWeb , :channel use ChannelHandler end Now you can start defining matchers and event handlers: defmodule MyAppWeb.PostChannel do use MyAppWeb , :channel use ChannelHandler join do handler fn _topic , _payload , socket -&gt; { :ok , socket } end end handlers do match &quot;comments:&quot; do handler MyAppWeb.PostCommentsHandler end event &quot;post:create&quot; do plug &amp; check_permission / 4 , :create_post handler fn payload , _bindings , socket case MyApp.Posts . create ( payload ) do { :ok , post } -&gt; { :reply , { :ok , post } , socket } { :error , reason } -&gt; { :reply , { :error , reason } , socket } end end end def check_permission ( socket , _payload , _bindings , permission ) do if MyApp.Authorization . can? ( socket . assigns . current_user , permission ) do # using :cont resumes the event handling { :cont , socket , payload , bindings } else # returning :reply or :noreply halts the event handling { :reply , { :error , &quot;Unauthorized&quot; } , socket } end end end end defmodule MyAppWeb.PostCommentsHandler do use ChannelHandler handlers do event &quot;create&quot; do handler fn payload , _bindings , socket do # Create a comment end end end end For more explanations about the API functions and what's possible, check the docs for ChannelHandler.API .","ref":"readme.html#usage","title":"Overview - Usage","type":"extras"},{"doc":"Copyright (c) 2021 dorgandash@gmail.com Licensed under the Apache License, Version 2.0 (the &quot;License&quot;); you may not use this file except in compliance with the License. You may obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0 Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.","ref":"readme.html#copyright-and-license","title":"Overview - Copyright and License","type":"extras"}]